VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form Test 
   Caption         =   "Test"
   ClientHeight    =   4020
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   7470
   LinkTopic       =   "Form1"
   ScaleHeight     =   4020
   ScaleWidth      =   7470
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command3 
      Caption         =   "Read Data"
      Enabled         =   0   'False
      Height          =   615
      Left            =   5160
      TabIndex        =   3
      Top             =   3120
      Width           =   1695
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Clear"
      Height          =   615
      Left            =   3240
      TabIndex        =   2
      Top             =   3120
      Width           =   1695
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid MSHFlexGrid1 
      Height          =   2775
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   6975
      _ExtentX        =   12303
      _ExtentY        =   4895
      _Version        =   393216
      _NumberOfBands  =   1
      _Band(0).Cols   =   2
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Create DB"
      Height          =   615
      Left            =   1320
      TabIndex        =   0
      Top             =   3120
      Width           =   1695
   End
End
Attribute VB_Name = "Test"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private mConn As ADODB.Connection
'/////////////////////////////////////////////////////////////////////
'//Synposis:
'//1. Create a table named AllFields if it does not exist. If the table exits,
'//delete all records from the table.
'//2. Insert some records into the table
'//3. Update the records using parameters which makes it easy for
'//binary data manipulation
'/////////////////////////////////////////////////////////////////////
Private Sub Command1_Click()
    On Error GoTo trap
    On Error GoTo trap
    Dim cmd As New ADODB.Command
    cmd.ActiveConnection = mConn
    
    
    If DoesTableExist("AllFields") Then     'delete all data from the table if table exists
        cmd.CommandText = "DELETE FROM AllFields;"
    Else  'create AllFields table if it does not exists
        cmd.CommandText = "CREATE TABLE AllFields(ID INTEGER PRIMARY KEY, Name VARCHAR(20), " _
            & "LongDoc MEDIUMTEXT, Image BLOB, Date5 DATE, datetime6 DATETIME, time6 TIME, " _
            & "timestamp7 TIMESTAMP, Year8 YEAR);"
    End If
    cmd.Execute
    cmd.CommandText = ""
    
    'insert data using multiple query statements
    Dim n As Long
    Dim I As Long
    For I = 0 To 300
        cmd.CommandText = cmd.CommandText _
            + "INSERT INTO AllFields (ID, Name, LongDoc, Date5, datetime6, time6, timestamp7, Year8) VALUES (" _
            & I & ", 'Sean D', 'this field can hold long long long long ... text string',  '2005-6-10', " _
            & "'2005-6-12 09:01:10', '6:05:00', '2005-6-15 1:22:11', 2005);"
    Next I
    mConn.BeginTrans
    cmd.Execute n
    mConn.CommitTrans

    'update records with Parameters
    Dim BA(999) As Byte
    For I = 0 To 999
        BA(I) = (I + 1) Mod 256
    Next I
    Dim params(2) As Parameter
    Set params(0) = New ADODB.Parameter
    params(0).Type = adInteger 'integer
    params(0).Value = 1
    Set params(1) = New ADODB.Parameter
    params(1).Type = adBSTR     'string
    params(1).Value = "Sean Deng"
    Set params(2) = New ADODB.Parameter
    params(2).Type = adBinary
    params(2).Value = BA
    params(2).Size = 1000
    cmd.CommandText = "UPDATE AllFields SET Name=?, Image=? WHERE ID=?;"
    'add parameters according to commend text
    cmd.Parameters.Append params(1)
    cmd.Parameters.Append params(2)
    cmd.Parameters.Append params(0)
    cmd.Execute
    
    'using transaction
    params(0).Value = 2
    mConn.BeginTrans
    cmd.Execute
    mConn.RollbackTrans 'the Name is NOT updated when read back
    params(0).Value = 3
    mConn.BeginTrans
    cmd.Execute
    mConn.CommitTrans 'the Name is updated when read back
    
    Me.Command3.Enabled = True
    Set cmd = Nothing
    MsgBox "Done"
    Exit Sub
trap:
    MsgBox Err.Description
    
    
End Sub
'/////////////////////////////////////////////////////////////////////
'//Synposis:
'//Clear all data from the data grid
'/////////////////////////////////////////////////////////////////////
Private Sub Command2_Click()
    On Error GoTo trap
    Me.MSHFlexGrid1.Clear
    Exit Sub
trap:
    MsgBox Err.Description
    
End Sub
'/////////////////////////////////////////////////////////////////////1
'//Synposis:
'//Create a recordset to get all data from the table and present the
'//data in a data grid.
'//To view the binary data read back from the database, you may open
'//open a watch window in the debug mode
'/////////////////////////////////////////////////////////////////////
Private Sub Command3_Click()

    On Error GoTo trap
    Dim BA As Variant
    Me.MSHFlexGrid1.Clear
    Dim rs As New ADODB.Recordset
    rs.Open "SELECT * FROM AllFields", mConn, adOpenStatic, adLockReadOnly
    If (rs.RecordCount > 3) Then
        rs.Move 3
        BA = rs("image").Value 'add BA to the watch window to view data
    End If
    
    Set Me.MSHFlexGrid1.Recordset = rs
    Exit Sub
trap:
    MsgBox Err.Description
    
End Sub
'/////////////////////////////////////////////////////////////////////
'//Synposis:
'//1. Create an ADO connection
'//2. Enable Read Data button if the table exists
'/////////////////////////////////////////////////////////////////////
Private Sub Form_Load()
    On Error GoTo trap
    Set mConn = New Connection
    'connect to MySQL server (localhost, port 3306), Database Name: test
    mConn.Open "Provider=OleMySql.MySqlSource.1; Data Source=localhost,3306; Initial Catalog=test", "root", "myPassword"
    If DoesTableExist("AllFields") Then
        Me.Command3.Enabled = True
    End If
    Exit Sub
trap:
    MsgBox Err.Description
End Sub
'/////////////////////////////////////////////////////////////////////
'//Synposis:
'//Check if the specified table exists. Return true if it does. Return false
'//otherwise.
'/////////////////////////////////////////////////////////////////////
Private Function DoesTableExist(ByVal sTable As String) As Boolean
    Dim rs As ADODB.Recordset
    Set rs = mConn.OpenSchema(adSchemaTables)
    While (Not rs.EOF)
        If UCase(rs("table_name")) = UCase(sTable) Then
            DoesTableExist = True
            Exit Function
        End If
        rs.MoveNext
    Wend
End Function

